#pragma once
#include "color.h"

// Default constructor -> no arguements
color::color()	
{
	// Initialize values
	red = 0;
	green = 0;
	blue = 0;
	alpha = 255; // white
}

// Constructor that takes 3 colours and an alpha
color::color(unsigned char const &red, unsigned char const &green, unsigned char const &blue, unsigned char const &alpha)
{
	// The 'this' pointer is a pointer to the object that invoked the constructor
	// and since it's a pointer, we have to use '->' (YES! SCORE! WHO'S THE KING?)
	this->red = red;
	this->green = green;
	this->blue = blue;
	this->alpha = alpha;
}

////////////////////////////////////////////////////////////////////////////////////
//operator overloading
////////////////////////////////////////////////////////////////////////////////////
std::ostream& operator << (std::ostream &os, color &rgba)
{
	os << rgba.red << " " << rgba.green << " " << rgba.blue << " " << rgba.alpha;
	return os;
}

////////////////////////////////////////////////////////////////////////////////////
color color::getColor()
{
	color rgba(red, green, blue, alpha);
	return rgba;
}