#pragma once
#include "vector.h"
#include "color.h"

class pixel
{
public:

	pixel ();
	//~pixel ();

	vector getCurrentPosition ();
	void setCurrentPosition (float const &x, float const &y, float const &z);
	void setCurrentPosition (vector const &v);

	vector getNextPosition ();
	void setNextPosition (float const &x, float const &y, float const &z);
	void setNextPosition (vector const &v);

	vector getFinalPosition ();
	void setFinalPosition (float const &x, float const &y, float const &z);
	void setFinalPosition (vector const &v);

	vector getVelocity ();
	void setVelocity (float const &x, float const &y, float const &z);
	void setVelocity (vector const &v);

	float getVelocityScalar();
	void setVelocityScalar (float &s);

	vector getPositionDifference ();

	float getPixelScale ();
	void setPixelScale (float const &scale);

	bool checkPosition ();
	color rgba;

private:

	vector currentPos;
	vector nextPos;
	vector finalPos;
	vector velocity;
	vector posDiff;
	float velocityScalar;
	float pixelScale;
	bool finalPosition;
};