#pragma once
#include "pixel.h"
#include "color.h"

////////////////////////////////////////////////////////////////////////////////////
//constructor
pixel::pixel()
{
	pDisplacement = 0.0;
	pScale = 1.0;
}

////////////////////////////////////////////////////////////////////////////////////
vector pixel::getPosition()
{
	return pPosition;
}

void pixel::setPosition(float const &x, float const &y, float const &z)
{
	pPosition.x = x;
	pPosition.y = y;
	pPosition.z = z;
}

void pixel::setPosition(vector const &v)
{
	pPosition = v;
}

////////////////////////////////////////////////////////////////////////////////////
void pixel::setScale(float &s)
{
	pScale = s;
}

float pixel::getScale()
{
	return pScale;
}

////////////////////////////////////////////////////////////////////////////////////
void pixel::setDisplacement(float &pDisplace)
{
	pDisplacement = pDisplace;
}

float pixel::getDisplacement()
{
	return pDisplacement;
}

////////////////////////////////////////////////////////////////////////////////////
void pixel::setColor(color &c)
{
	rgba.red = c.red;
	rgba.green = c.green;
	rgba.blue = c.blue;
	rgba.alpha = c.alpha;
}

void pixel::setColor(int &r, int &g, int &b, int &a)
{
	rgba.red = r;
	rgba.green = g;
	rgba.blue = b;
	rgba.alpha = a;
}