#pragma once
#include <iostream>
#include "wrapper.h"
#include "vector.h"

////////////////////////////////////////////////////////////////////////////////////
class menu
{
public:
	menu();
	~menu();

	std::string getpColorMap();
	void setpColorMap(std::string pColorMap);
	vector getVolumeScalar();
	void setVolumeScalar(vector volumeScalar);

	std::string getpOpacityMap();
	float getpOpacityConstant();
	void setpOpacityMap(std::string pOpacityMap);
	void setpOpacityConstant (float &pOpacityConstant);

	std::string getpVelocityMap();
	double getpVelocityConstant();
	double getpVelocityMinConstant();
	double getpVelocityMaxConstant();
	void setpVelocityMap(std::string pVelocityMap);
	void setpVelocityConstant (double &pVelocityConstant);
	void setpVelocityMinConstant (double pVelocityMinConstant);
	void setpVelocityMaxConstant (double pVelocityMaxConstant);

	std::string getpHeightMap();
	float getpHeightMaxConstant();
	void setpHeightMap(std::string pHeightMap);
	void setpHeightMaxConstant (float &pHeightMaxConstant);

	std::string getpScaleMap();
	float getpScaleConstant();
	void setpScaleMap(std::string pScaleMap);
	void setpScaleConstant (float &pScaleConstant);

	void showMainMenu();
	void showMenuItem1();
	void showMenuItem11();
	void showMenuItem12();
	void showMenuItem2();
	void showMenuItem21();
	void showMenuItem22();
	void showMenuItem23();
	void showMenuItem24();
	void showMenuItem25();
	void showMenuItem26();
	void showMenuItem27();
	void showMenuItem3();
	void showMenuItem4();
	void showMenuItem5();
	void showErrorMessage();

private:
	char menuItem;
	vector volumeScalar;
	float pOpacityConstant;
	double pVelocityConstant;
	double pVelocityMinConstant;
	double pVelocityMaxConstant;
	float pHeightMaxConstant;
	float pScaleConstant;
	std::string pColorMap;
	std::string pOpacityMap;
	std::string pVelocityMap;
	std::string pHeightMap;
	std::string pScaleMap;
};