#pragma once
#include "animation.h"
#include "frame.h"

////////////////////////////////////////////////////////////////////////////////////
animation::animation(unsigned int nFrames, unsigned int nPixels)
{
	numberOfFrames = nFrames;
	frames = new frame*[numberOfFrames];
	for (unsigned int i = 0; i < numberOfFrames; i++)
	{
		frames[i] = new frame(nPixels);
	}
}

////////////////////////////////////////////////////////////////////////////////////
animation::~animation()	
{
	if (frames != NULL)
	{
		delete [] frames;
	}
}

////////////////////////////////////////////////////////////////////////////////////
unsigned int animation::getNumberOfFrames()
{
	return numberOfFrames;
}

void animation::setNumberOfFrames(unsigned int nFrames)
{
	numberOfFrames = nFrames;
}