#pragma once
#include "animation.h"
#include "keyframe.h"

////////////////////////////////////////////////////////////////////////////////////
animation::animation(unsigned int nKeyFrames, unsigned int nPixels)
{
	numberOfKeyFrames = nKeyFrames;
	keyframes = new keyframe*[numberOfKeyFrames];
	for (unsigned int i = 0; i < numberOfKeyFrames; i++)
	{
		keyframes[i] = new keyframe(nPixels);
	}
}

////////////////////////////////////////////////////////////////////////////////////
animation::~animation()	
{
	if (keyframes != NULL)
	{
		delete [] keyframes;
	}
}

////////////////////////////////////////////////////////////////////////////////////
unsigned int animation::getNumberOfKeyFrames()
{
	return numberOfKeyFrames;
}

void animation::setNumberOfKeyFrames(unsigned int nKeyFrames)
{
	numberOfKeyFrames = nKeyFrames;
}