#pragma once
#include <vector>
#include "wrapper.h"

////////////////////////////////////////////////////////////////////////////////////
class menu
{
public:
	menu();
	~menu();

	void setConfigurationFile(std::string configurationPath);
	std::string getConfigurationFile();

	bool getbConfigurationFile();

	unsigned short int getNumberOfImages();

	void setKeyframePath(std::string keyframePath);
	std::string getKeyframePath(unsigned short int keyframeNumber);

	void setInterpolationFrames(unsigned short int nInterpolationFrames);
	unsigned short int getInterpolationFrames(unsigned short int keyframeNumber);

	void setMinDisplacement(float minHeightDisplacement);
	float getMinDisplacement();

	void setMaxDisplacement(float maxHeightDisplacement);
	float getMaxDisplacement();

	void displayError();

	std::vector <wrapper> image;
	wrapper * mImage;
	void showMainMenu();
	void showMenuItem1();
	void showMenuItem2();
	void showMenuItem5();
	void showErrorMessage();

private:
	bool bConfigurationFile;
	float minDisplacement;
	float maxDisplacement;
	char menuItem;
	unsigned short int iNumberOfImages;
	std::string strConfigurationFile;
	std::vector <std::string> vKeyframePath;
	std::vector <unsigned short int> vInterpolationFrame;
};